<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/



// Delete: domain/mail - IP
if (am_i_server_admin(4) AND is_valid_id($_GET['delete']) AND ($_GET['type'] == "domain" OR $_GET['type'] == "ip")) {
	$del_type = $_GET['type'];
	// Sender
	if ($_GET['type'] == "domain") {
		$del_ar = $cnx->select_row("id,domain", "domain_access", "WHERE `id` = ".$_GET['delete']."");
		$del_table = "domain_access";
		//$deleted = $del_ar['domain'];
	}
	// IP
	if ($_GET['type'] == "ip") {
		$del_ar = $cnx->select_row("id,ip", "ip_access", "WHERE `id` = ".$_GET['delete']."");
		$del_table = "ip_access";
		//$deleted = $del_ar['ip'];
	}
	if ($del_ar['id'] == $_GET['delete']) {
		if ($_GET['confirm']) {
			//delete
			$q = $cnx->delete($del_ar['id'], $del_table, "id");
			if (is_valid_id($q)) {
				$content['status'][] = "<strong>".$del_ar[$del_type]."</strong> deleted";
			} else {
				$content['errors'][] = "Error deleting from database";
				$content['errors'][] = $q;
			}
		} else {
			$content['sender_acls']['confirm_delete'][$del_type] = $del_ar[$del_type];
			$content['sender_acls']['confirm_delete']['confirm_link'] = genlink("page=sender_acls|delete=".$_GET['delete']."|type=$del_type|confirm=1");
			$content['sender_acls']['confirm_delete']['cancel_link'] = genlink("page=sender_acls");
		}
	}
}


// Edit and add requires level 4 permission
if (am_i_server_admin(4)) {

	// Edit domain
	if (is_valid_id($_GET['edit'])) {
		if ($_GET['type'] == "domain") {
			$edit_ar = $cnx->select_row("*", "domain_access", "WHERE `id` = ".$_GET['edit']."");
			// Add: domain/mail
			$reject_sender_form = new FormMaker("edit_reject_sender", genlink("page=sender_acls|edit=".$edit_ar['id']."|type=domain"));
			$reject_sender_form->add_element("domain", "text", "custom|$reg_email_or_domain", 1);
			$reject_sender_form->set_display_name("domain", "Domain/email");
			$reject_sender_form->add_element("state", "radio", "monoselect|OK=Accept:REJECT=Reject", 1);
			$reject_sender_form->set_display_name("state", "Status");
			$reject_sender_form->add_element("note", "textarea", "free");
			$reject_sender_form->set_display_name("note", "Note (optional)");
			$reject_sender_form->add_element("bounce_message", "textarea", "free");
			$reject_sender_form->set_display_name("bounce_message", "Bounce Message (optional)");
			// POST
			if ($_POST['edit_reject_sender']) {
				$reject_sender_form->check_post($_POST);
				if (!$reject_sender_form->errors()) {
					$insert_array = $reject_sender_form->get_values();
					$q = $cnx->update($insert_array, "domain_access", $edit_ar['id']);
					if (is_valid_id($q)) {
						$content['status'][] = "Added rule for <strong>".$insert_array['domain']."</strong>";
						$content['status'][] = "Updated settings for <strong>".$insert_array['domain']."</strong>";
					} else {
						$content['errors'][] = "Error updating database";
						$content['errors'][] = $q;
					}
				} else {
					$content['errors'][] = "Form contains errors";
				}
			} else {
				// prefill vars
				$reject_sender_form->set_value("domain", $edit_ar['domain']);
				$reject_sender_form->set_value_and_validate("state", $edit_ar['state']);
				$reject_sender_form->set_value("note", $edit_ar['note']);
			}
			$content['sender_acls']['forms']['edit_reject_sender'] = $reject_sender_form->result();
		} else if ($_GET['type'] == "ip") {
			$edit_ar = $cnx->select_row("*", "ip_access", "WHERE `id` = ".$_GET['edit']."");
			// Add: domain/mail
			$reject_sender_form = new FormMaker("edit_reject_ip", genlink("page=sender_acls|edit=".$edit_ar['id']."|type=ip"));
			$reject_sender_form->add_element("ip", "text", "ip", 1);
			$reject_sender_form->set_display_name("ip", "IP");
			$reject_sender_form->add_element("state", "radio", "monoselect|OK=Accept:REJECT=Reject", 1);
			$reject_sender_form->set_display_name("state", "Status");
			$reject_sender_form->add_element("note", "textarea", "free");
			$reject_sender_form->set_display_name("note", "Note (optional)");
			$reject_sender_form->add_element("bounce_message", "textarea", "free");
			$reject_sender_form->set_display_name("bounce_message", "Bounce Message (optional)");
			// POST
			if ($_POST['edit_reject_ip']) {
				$reject_sender_form->check_post($_POST);
				if (!$reject_sender_form->errors()) {
					$insert_array = $reject_sender_form->get_values();
					$q = $cnx->update($insert_array, "ip_access", $edit_ar['id']);
					if (is_valid_id($q)) {
						$content['status'][] = "Updated settings for <strong>".$insert_array['ip']."</strong>";
					} else {
						$content['errors'][] = "Error updating database";
						$content['errors'][] = $q;
					}
				} else {
					$content['errors'][] = "Form contains errors";
				}
			} else {
				// prefill vars
				$reject_sender_form->set_value("ip", $edit_ar['ip']);
				$reject_sender_form->set_value_and_validate("state", $edit_ar['state']);
				$reject_sender_form->set_value("note", $edit_ar['note']);
			}
			$content['sender_acls']['forms']['edit_reject_ip'] = $reject_sender_form->result();
		}
	}

	// Add: domain/mail
	$reject_sender_form = new FormMaker("reject_sender", genlink("page=sender_acls"));
	$reject_sender_form->add_element("domain", "text", "custom|$reg_email_or_domain", 1);
	$reject_sender_form->set_display_name("domain", "Domain/email");
	$reject_sender_form->add_element("state", "radio", "monoselect|OK=Accept:REJECT=Reject", 1);
	$reject_sender_form->set_display_name("state", "Status");
	$reject_sender_form->add_element("note", "textarea", "free");
	$reject_sender_form->set_display_name("note", "Note (optional)");
	$reject_sender_form->add_element("bounce_message", "textarea", "free");
	$reject_sender_form->set_display_name("bounce_message", "Bounce Message (optional)");
	// POST
	if ($_POST['reject_sender']) {
		$reject_sender_form->check_post($_POST);
		if (!$reject_sender_form->errors()) {
			$insert_array = $reject_sender_form->get_values();
			$q = $cnx->insert($insert_array, "domain_access");
			if (is_valid_id($q)) {
				$content['status'][] = "Added rule for <strong>".$insert_array['domain']."</strong>";
				$reject_sender_form->set_value("domain", "");
				$reject_sender_form->set_value("state", "");
				$reject_sender_form->set_value("note", "");
			} else {
				$content['errors'][] = "Error inserting into database";
				$content['errors'][] = $q;
			}
		} else {
			$content['errors'][] = "Form contains errors";
		}
	}
	$content['sender_acls']['forms']['add_reject_sender'] = $reject_sender_form->result();

	// Add IP
	$reject_ip_form = new FormMaker("reject_ip", genlink("page=sender_acls"));
	$reject_ip_form->add_element("ip", "text", "ip", 1);
	$reject_ip_form->set_display_name("ip", "IP");
	$reject_ip_form->add_element("state", "radio", "monoselect|OK=Accept:REJECT=Reject", 1);
	$reject_ip_form->set_display_name("state", "Status");
	$reject_ip_form->add_element("note", "textarea", "free");
	$reject_ip_form->set_display_name("note", "Note (optional)");
	$reject_ip_form->add_element("bounce_message", "textarea", "free");
	$reject_ip_form->set_display_name("bounce_message", "Bounce Message (optional)");
	// POST
	if ($_POST['reject_ip']) {
		$reject_ip_form->check_post($_POST);
		if (!$reject_ip_form->errors()) {
			$insert_array = $reject_ip_form->get_values();

			// Insert new
			$q = $cnx->insert($insert_array, "ip_access");
			if (is_valid_id($q)) {
				$content['status'][] = "Added rule for <strong>".$insert_array['ip']."</strong>";
				$reject_ip_form->set_value("ip", "");
				$reject_ip_form->set_value("state", "");
				$reject_ip_form->set_value("note", "");
			} else {
				$content['errors'][] = "Error inserting into database";
				$content['errors'][] = $q;
			}

		} else {
			$content['errors'][] = "Form contains errors";
		}
	}
	$content['sender_acls']['forms']['add_reject_ip'] = $reject_ip_form->result();

}

// List: domain/mail - IP
if (am_i_server_admin(1)) {

	$order_stuff = check_order_by('domain_access');
	$order_by = $order_stuff['order_by'];
	$content['sender_acls']['list']['domains']['order_by'] = $order_stuff['th'];
	$content['sender_acls']['list']['domains']['domains'] = $cnx->select("*", "domain_access", $order_by);
	if (am_i_server_admin(4) AND is_array($content['sender_acls']['list']['domains']['domains'])) {
		foreach ($content['sender_acls']['list']['domains']['domains'] as $k => $v) {
			$content['sender_acls']['list']['domains']['domains'][$k]['details_link'] = genlink("page=sender_acls|edit=".$v['id']."|type=domain");
			$content['sender_acls']['list']['domains']['domains'][$k]['delete_link'] = genlink("page=sender_acls|delete=".$v['id']."|type=domain");
		}
	}

	$order_stuff = check_order_by('ip_access');
	$order_by = $order_stuff['order_by'];
	$content['sender_acls']['list']['ips']['order_by'] = $order_stuff['th'];
	$content['sender_acls']['list']['ips']['ips'] = $cnx->select("*", "ip_access", $order_by);
	if (am_i_server_admin(4) AND is_array($content['sender_acls']['list']['ips']['ips'])) {
		foreach ($content['sender_acls']['list']['ips']['ips'] as $k => $v) {
			$content['sender_acls']['list']['ips']['ips'][$k]['details_link'] = genlink("page=sender_acls|edit=".$v['id']."|type=ip");
			$content['sender_acls']['list']['ips']['ips'][$k]['delete_link'] = genlink("page=sender_acls|delete=".$v['id']."|type=ip");
		}
	}
}

?>
