<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>


<h2 class="pagetitle">
	<?php if (am_i_admin_of($content['account_details']['details']['domain_id'])) { ?>
		<a href="<?php echo genlink("page=accounts|domain_id=".$content['account_details']['details']['domain_id'].""); ?>"><?php echo $content['account_details']['details']['domain']; ?></a>
	<?php } else { ?>
		<?php echo $content['account_details']['details']['domain']; ?>
	<?php } ?>
</h2>


<?php // edit account form
if ($content['account_details']['forms']['edit_account_form']) { ?>
	<fieldset>
		<legend>Edit account</legend>
	<?php	$edit_account_form = new FormPrinter($content['account_details']['forms']['edit_account_form']);
		// Configure base css class for input fields
		$edit_account_form->configure_css("input", "input-text");
		$edit_account_form->configure_css("submit", "input-submit");
		// used for "admin_of"
		$edit_account_form->configure_css("checkbox", "table");
		$edit_account_form->configure_css("label", "table");
		// Generate form
		$edit_account_form->auto_generate_form();
		$edit_account_form->insert_html('<div class="clear"></div>');
		$edit_account_form->print_form("Update"); ?>
	</fieldset>
<?php } ?>


<?php // edit alias form ?>
<?php if ($content['account_details']['forms']['edit_alias_form']) { ?>
	<fieldset>
		<legend>Edit alias</legend>
	<?php	$edit_alias_form = new FormPrinter($content['account_details']['forms']['edit_alias_form']);
		// Configure base css class for input fields
		$edit_alias_form->configure_css("input", "input-text");
		$edit_alias_form->configure_css("submit", "input-submit");
		// Generate form
		$edit_alias_form->auto_generate_form();
		$edit_alias_form->print_form("Update"); ?>
	</fieldset>
<?php } ?>
